#include "TI92dasm.h"

tBuffer * GetFile(char * Name)
{
 FILE * InFile;
 tBuffer * Buffer;
 word Size;
 word i;
 byte Tmp[2];

 if(!(Buffer = (tBuffer *)Errmalloc(sizeof(tBuffer)))) return NULL;

 if(!(InFile = fopen(Name, "rb"))) return NULL;

 fseek(InFile, 0x40, SEEK_SET);
 fread(Buffer->Name, 8, 1, InFile);
 Buffer->Name[8] = 0;

 fseek(InFile, 0x56, SEEK_SET);
 fread(Tmp, 2, 1, InFile);
 Size = ToWord(Tmp);

 if(!(Buffer->File = (byte *)Errmalloc(Size))) return NULL;

 if(fread(Buffer->File, 1, Size, InFile) != Size) return NULL;

 if(Buffer->File[Size-1] != 0xF3) return NULL;

 // Allocation avec initialisation  TO_OUTPUT
 if(!(Buffer->Flags = (byte *)Errmalloc(Size))) return NULL;
 for(i = 0 ; i < Size ; i++)
    Buffer->Flags[i] = TO_OUTPUT;

 Buffer->Size = Size;

 fclose(InFile);
 return Buffer;
}

word ToWord(byte * ptr)
{
 word Ret = *ptr << 8;
 Ret += *(ptr+1);

 return Ret;
}