enum tItemType {TypeAny, TypeROM_CALL, TypeRAM_CALL, TypeImported, TypeReloc, TypeLabel, TypeEntryPoint, TypeDisas, TypeTexte, TypeData, TypeBSS};

typedef struct sListItem tListItem;

struct sListItem
{
 tListItem * Next;
 enum tItemType Type;
 word Offset;
 char * Label; // If not in the prog
 word PointTo; // If in the prog
};

class List
{
    private:
       tListItem * First;
       tListItem * Last;
       word NbItems;

    public:
       List();
       void Add(tItemType pType, word pOffset, char * pLabel, word pPointTo);
       void SortFollowingToOffset();
       tListItem * Search(word Offset);
       void Print(char * str);
       tListItem * GetNext(tListItem * Current, word pType = TypeAny);
       void Merge(List TheList);
       int card();
       int Rm(tListItem * WhichOne = NULL);
       void List::Free();
};
